{$APPTYPE CONSOLE}

uses SysUtils, Math;

type Tlong = array[0..10000] of integer;

var i, j, k1, k2, l, n, m, q, rect, MaxO, in1, in2: integer ;
    x, y, v : array[1..3] of Tlong;
    hor, hor1, tmp: Tlong;
    fo: text;

procedure _Write(var a: Tlong);
var i: integer;
begin
  if a[0] < 0 then write(fo, '-');
  for i := abs(a[0]) downto 1 do
    write(fo, a[i]);
  writeln(fo);
end;

function less(var a, b: Tlong): boolean;
var i: integer;
begin
  Result := false;
  if a[0] <> b[0] then begin Result := a[0] < b[0]; exit; end;
  for i := a[0] downto 1 do
    if a[i] <> b[i] then begin Result := a[i] < b[i]; exit; end;
end;

function lessequal(var a, b: Tlong): boolean;
var i: integer;
begin
  Result := false;
  if a[0] <> b[0] then begin Result := a[0] <= b[0]; exit; end;
  for i := a[0] downto 1 do
    if a[i] <> b[i] then begin Result := a[i] <= b[i]; exit; end;
end;

procedure swap(var a, b: Tlong);
var t: Tlong;
begin
  t := a; a := b; b := t;
end;

procedure GenInt;
begin
  if MaxO < 0 then
    begin
      in1 := MaxO; in2 := -MaxO;
    end
  else
    begin
      in1 := -MaxO div 2 - random(MaxO div 2)-1;
      in2 := MaxO div 2 + random(MaxO div 2 +1);
    end;
end;

function GenLong(var l, r: integer): Tlong;
var i, p: integer;
begin
  p := max(abs(l), r);
  Result[0] := p;
  Result[p] := random(9) + 1;
  //if abs(l) = r then Result[p] := 1;
  for i := 1 to p - 1 do
    Result[i] := random(10);
  //if p > r then Result[0] := -Result[0];
end;                                  

begin
  MaxO := StrToInt(ParamStr(1));
  randseed := StrToInt(ParamStr(2));
  rect := StrToInt(ParamStr(3));
  AssignFile(fo, 'input.txt');
  rewrite(fo);
  GenInt;
  hor := GenLong(in1, in2);
  repeat
    GenInt;
    hor1 := GenLong(in1, in2);
  until not (less(hor, hor1) and not lessequal(hor, hor1));
  for i := 1 to 3 do
    begin
      GenInt;
      v[i] := GenLong(in1, in2);
      if random(2) = 0 then v[i, 0] := -v[i, 0];
    end;
  if rect = 1 then v[3] := v[random(2)+1];
  for i := 1 to 3 do
    for j := 1 to 2 do
      if less(v[j+1], v[j]) then swap(v[j+1], v[j]);
  y[1] := hor; y[2] := hor1; y[3] := hor;
  x := v;
  for i := 1 to 10 do
    begin
      if random(2) = 0 then
        begin
          k1 := random(3) + 1;
          k2 := random(3) + 1;
          swap(x[k1], x[k2]); swap(y[k1], y[k2]);
        end
      else
        begin
          swap(x[1], y[1]); swap(x[2], y[2]); swap(x[3], y[3]);
        end;
    end;
  if rect = -1 then
    begin
      for i := 1 to 6 do
        begin
          GenInt;
          tmp := GenLong(in1, in2);
          if random(2) = 0 then tmp[0] := -tmp[0];
          _write(tmp);
        end;
    end
  else
    for i := 1 to 3 do
      begin
        _write(x[i]); _write(y[i]);
      end;
  CloseFile(fo);
end.