#include <iostream>
#include <string>

using namespace std;

const int maxn = 2100;
const int len = 1100;
const int sz = maxn*sizeof(int);

int a[3][2][maxn],mega[maxn],res[maxn],dx[maxn],dy[maxn],dx1[maxn],dy1[maxn],d[maxn];
int p[maxn],q[maxn],tmp[maxn],res1[maxn];

void Add(int* a, int* b)
{
   int i,j,ost = 0;
   for (i = 1; i <= b[0]; i++) {
      j = a[i] + b[i] + ost;
      a[i] = j%10; ost = j/10;
   }
   i = b[0];
   while (ost) {
      i++; j = a[i] + ost;
      a[i] = j%10; ost = j/10;
   }
   if (i > a[0]) a[0] = i;
}

void Sub(int* a, int* b)
{
   int i,j,ost = 0;
   for (i = 1; i <= max(a[0],b[0]); i++) {
      j = a[i] - b[i] - ost; ost = 0;
      while (j < 0) {j += 10; ost++;}
      a[i] = j;
   }
   while (a[0] > 1 && !a[a[0]]) a[0]--;
}

void Div2(int* a)
{
   int i,j,ost = 0;
   for (i = a[0]; i >= 1; i--) {
      j = ost*10 + a[i]; a[i] = j/2; ost = j%2;
   }
   while (a[0] > 1 && !a[a[0]]) a[0]--;
}

void Mull(int* a, int* b, int* c)
{
   int i,j;
   memset(c,0,sz);
   for (i = 1; i <= a[0]; i++)
      for (j = 1; j <= b[0]; j++) {
         c[i+j-1] += a[i]*b[j];
         c[0] = max(c[0],i+j-1);
      }
   int ost = 0;
   for (i = 1; i <= c[0]; i++) {
      j = c[i] + ost; c[i] = j%10; ost = j/10;
   }
   while (ost) {
      c[0]++; c[c[0]] = ost%10; ost /= 10;
   }
   while (a[0] > 1 && !a[a[0]]) a[0]--;
}

int Cmp(int* a, int* b)
{
   if (a[0] < b[0]) return -1;
   if (a[0] > b[0]) return 1;
   for (int i = a[0]; i >= 1; i--) {
      if (a[i] < b[i]) return -1;
      if (a[i] > b[i]) return 1;
   }
   return 0;
}

void GCD(int* a, int* b, int* d)
{
   if (Cmp(a,b) < 0) swap(a,b);
   memcpy(d,a,sz); memcpy(q,b,sz);
   int i,j;
   while (q[0] > 1 || q[1] > 0) {
      while (Cmp(d,q) >= 0) {
         memcpy(p,q,sz);
         j = d[0] - p[0] - 1;
         if (j > 0) {
            for (i = p[0]; i >= 1; i--) p[i+j] = p[i];
            for (i = 1; i <= j; i++) p[i] = 0;
            p[0] += j;
         }
         Sub(d,p);
      }
      memcpy(tmp,d,sz); memcpy(d,q,sz); memcpy(q,tmp,sz);
   }
}

void RL(int* x)
{
   string s; cin >> s;
   int i,l;
   if (s[0] == '-') l = 1; else l = 0;
   x[0] = s.length() - l;
   for (i = l; i < s.length(); i++) x[i-l+1] = s[i] - '0';
   for (i = 1; i <= x[0]/2; i++) swap(x[i],x[x[0]-i+1]);
   if (l) {
      for (i = 1; i <= len; i++) x[i] = 9-x[i];
      x[0] = len;
   } else Add(x,mega);
}

void Solve1(int* dx, int* dy, int* a)
{
   GCD(dx,dy,d); Mull(dx,dy,a); Add(a,d); Sub(a,dx); Sub(a,dy); Div2(a);
}

void Solve(int i, int j, int k)
{
   int m = 3-i-j;
   memcpy(dx,a[m][k],sz); Sub(dx,a[i][k]);
   memcpy(dx1,a[j][k],sz); Sub(dx1,a[m][k]);
   if (Cmp(a[i][1-k],a[m][1-k]) > 0) {
      memcpy(dy,a[i][1-k],sz); Sub(dy,a[m][1-k]);
   } else {
      memcpy(dy,a[m][1-k],sz); Sub(dy,a[i][1-k]);
   }
   memcpy(dy1,dy,sz);
   Solve1(dx,dy,res); Solve1(dx1,dy1,res1);
   Add(res,res1);
}

int main()
{
   int i,j,k;

   freopen("input.txt","rt",stdin); freopen("output.txt","wt",stdout);

   mega[0] = len; for (i = 1; i <= len; i++) mega[i] = 9;
   for (i = 0; i < 3; i++) 
      for (j = 0; j < 2; j++) RL(a[i][j]);

   int ok = 0, sc = 1;
   for (j = 0; j < 2; j++)
      if (!Cmp(a[0][j],a[1][j]) && !Cmp(a[2][j],a[1][j])) {
         sc = 0; break;
      }
   for (i = 0; i < 3; i++)
      for (j = i+1; j < 3; j++)
         for (k = 0; k < 2; k++)
            if (sc && !(sc = Cmp(a[i][k],a[j][k]))) {
               int m = 3-i-j;
               if (Cmp(a[i][1-k],a[m][1-k]) <= 0 && Cmp(a[m][1-k],a[j][1-k]) <= 0) {Solve(i,j,1-k); ok = 1;} else 
               if (Cmp(a[j][1-k],a[m][1-k]) <= 0 && Cmp(a[m][1-k],a[i][1-k]) <= 0) {Solve(j,i,1-k); ok = 1;}
            }

   if (ok)
      for (i = res[0]; i >= 1; i--) cout << res[i];
   else cout << -1;
   fclose(stdin); fclose(stdout);
   return 0;
}

